diff -u arc2/news.arc arc3/news.arc
--- arc2/news.arc	2008-02-24 20:39:48.000000000 -0500
+++ arc3/news.arc	2009-05-30 17:09:15.000000000 -0400
@@ -1,5 +1,6 @@
 ; News.  2 Sep 06.
 
+
 ; to run news: (nsv)
 ; put usernames of admins, separated by whitespace, in arc/admins
 
@@ -8,7 +9,7 @@
    parent-url*   "http://www.yourdomain.com"
    favicon-url*  ""
    site-desc*    "What this site is about."               ; for rss feed
-   site-color*   orange
+   site-color*   (color 160 180 200)
    prefer-url*   t)
 
 
@@ -25,10 +26,11 @@
   auth       0
   member     nil
   submitted  nil
+  votes      nil   ; for now just recent, elts each (time id by sitename dir)
   karma      1
+  avg        nil
   weight     .5
   ignore     nil
-  nodowns    nil
   email      nil
   about      nil
   showdead   nil
@@ -38,7 +40,8 @@
   maxvisit   20 
   minaway    180
   topcolor   nil
-  keys       nil)
+  keys       nil
+  delay      0)
 
 (deftem item
   id         nil
@@ -52,10 +55,13 @@
   votes      nil   ; elts each (time ip user type score)
   score      0
   sockvotes  0
+  flags      nil
   dead       nil
   deleted    nil
+  parts      nil
   parent     nil
-  kids       nil)
+  kids       nil
+  keys       nil)
 
 
 ; Load and Save
@@ -67,10 +73,12 @@
 
 (= votes* (table) profs* (table))
 
+(= initload-users* nil)
+
 (def nsv ((o port 8080))
   (map ensure-dir (list arcdir* newsdir* storydir* votedir* profdir*))
   (unless stories* (load-items))
-  (if (empty profs*) (load-users))
+  (if (and initload-users* (empty profs*)) (load-users))
   (asv port))
 
 (def load-users ()
@@ -78,13 +86,34 @@
   (noisy-each 100 id (dir profdir*)
     (load-user id)))
 
+; For some reason vote files occasionally get written out in a 
+; broken way.  The nature of the errors (random missing or extra
+; chars) suggests the bug is lower-level than anything in Arc.
+; Which unfortunately means all lists written to disk are probably
+; vulnerable to it, since that's all save-table does.
+
 (def load-user (u)
   (= (votes* u) (load-table (+ votedir* u))
      (profs* u) (temload 'profile (+ profdir* u)))
   u)
 
+; Have to check goodname because some user ids come from http requests.
+; So this is like safe-item.  Don't need a sep fn there though.
+
+(def profile (u)
+  (or (profs* u)
+      (aand (goodname u)
+            (file-exists (+ profdir* u))
+            (= (profs* u) (temload 'profile it)))))
+
+(def votes (u)
+  (or (votes* u)
+      (aand (file-exists (+ votedir* u))
+            (= (votes* u) (load-table it)))))
+          
 (def init-user (u)
-  (= (votes* u) (table) (profs* u) (inst 'profile 'id u))
+  (= (votes* u) (table) 
+     (profs* u) (inst 'profile 'id u))
   (save-votes u)
   (save-prof u)
   u)
@@ -95,17 +124,42 @@
 ; news app need to call this in the after-login fn.
 
 (def ensure-news-user (u)
-  (if (profs* u) u (init-user u)))
+  (if (profile u) u (init-user u)))
 
 (def save-votes (u) (save-table (votes* u) (+ votedir* u)))
 
 (def save-prof  (u) (save-table (profs* u) (+ profdir* u)))
 
-(mac uvar (u k) `((profs* ,u) ',k))
+(mac uvar (u k) `((profile ,u) ',k))
+
+(mac karma   (u) `(uvar ,u karma))
+(mac ignored (u) `(uvar ,u ignore))
+
+; Note that users will now only consider currently loaded users.
+
+(def users ((o f idfn)) 
+  (keep f (keys profs*)))
+
+(def check-key (u k)
+  (and u (mem k (uvar u keys))))
+
+(def set-key (u k)
+  (do1 (pushnew k (uvar u keys))
+       (save-prof u)))
+
+(def unset-key (u k)
+  (do1 (pull k (uvar u keys))
+       (save-prof u)))
+
+(def toggle-key (u k)
+  (do1 (atomic
+         (if (mem k (uvar u keys))
+             (pull k (uvar u keys))
+             (push k (uvar u keys))))
+       (save-prof u)))
 
-(mac karma (u) `(uvar ,u karma))
+(def author (u i) (is u i!by))
 
-(def users (f) (keep f (keys profs*)))
 
 (= stories* nil comments* nil items* (table) url->story* (table)
    maxid* 0 initload* 15000)
@@ -117,17 +171,21 @@
 ; Note that stories* etc only include the initloaded (i.e. recent)
 ; ones, plus those created since this server process started.
 
-; Could be smarter about preloading by keeping track of most popular pages.
+; Could be smarter about preloading by keeping track of popular pages.
 
 (def load-items ()
+  (system (+ "rm " storydir* "*.tmp"))
   (pr "load items: ") 
   (with (items (table)
-         ids   (sort > (map [coerce _ 'int] (dir storydir*))))
+         ids   (sort > (map int (dir storydir*))))
     (if ids (= maxid* (car ids)))
     (noisy-each 100 id (firstn initload* ids)
       (let i (load-item id)
         (push i (items i!type))))
-    (= stories*  (rev items!story) comments* (rev items!comment))
+    (= stories*  (rev (merge (compare < get!id)
+                             items!story 
+                             items!poll))
+       comments* (rev items!comment))
     (hook 'initload items))
   (ensure-topstories))
 
@@ -135,30 +193,51 @@
   (aif (errsafe (readfile1 (+ newsdir* "topstories")))
        (= ranked-stories* (map item it))
        (do (prn "ranking stories.") 
+           (flushout)
            (gen-topstories))))
 
 (def astory   (i) (is i!type 'story))
-
 (def acomment (i) (is i!type 'comment))
+(def apoll    (i) (is i!type 'poll))
 
 (def load-item (id)
   (let i (temload 'item (string storydir* id))
-    (= (items* id) i (i 'id) id)
-    (awhen (and (astory i) (live i) i!url)
-      (= (url->story* it) i))
+    (= (items* id) i)
+    (awhen (and (astory i) (live i) (check i!url ~blank))
+      (register-url i it))
     i))
 
+; Note that duplicates are only prevented of items that have at some 
+; point been loaded. 
+
+(def register-url (i url)
+  (= (url->story* (canonical-url url)) i!id))
+
+; redefined later
+
+(= stemmable-sites* (table))
+
+(def canonical-url (url)
+  (if (stemmable-sites* (sitename url))
+      (stem-url url)
+      url))
+
+(def stem-url (url) 
+  (cut url 0 (pos #\? url)))
+
 (def new-item-id ()
   (let id (++ maxid*)
-    (if (file-exists (string storydir* id)) (new-item-id) id)))
+    (if (file-exists (string storydir* id)) 
+        (new-item-id) 
+        id)))
 
 (def item (id)
-  (or (items* id) (errsafe (load-item id))))
+  (or (items* id) (errsafe:load-item id)))
 
-(def kids (x) (map item x!kids))
+(def kids (i) (map item i!kids))
 
-; For use on external item references (from urls).
-; Checks id is int because people try e.g. item?id=363/blank.php
+; For use on external item references (from urls).  Checks id is int 
+; because people try e.g. item?id=363/blank.php
 
 (def safe-item (id)
   (let id (if (isa id 'string) (saferead id) id)
@@ -176,9 +255,29 @@
 
 (def save-item (i) (save-table i (string storydir* i!id)))
 
-(def kill (i)
-  (assert i!dead)
-  (save-item i))
+(def kill (i how)
+  (unless i!dead
+    (log-kill i how)
+    (wipe (comment-cache* i!id))
+    (set i!dead)
+    (save-item i)))
+
+(= kill-log* nil)
+
+(def log-kill (i how)
+  (push (list i!id how) kill-log*))
+
+(mac each-loaded-item (var . body)
+  (w/uniq g
+    `(let ,g nil
+       (loop (= ,g maxid*) (> ,g 0) (-- ,g)
+         (whenlet ,var (items* ,g)
+           ,@body)))))
+
+(def loaded-items (test)
+  (accum a
+    (each-loaded-item i 
+      (when (test i) (a i)))))
 
 (def newslog args (apply srvlog 'news args))
 
@@ -188,17 +287,38 @@
 ; Votes divided by the age in hours to the gravityth power.
 ; Would be interesting to scale gravity in a slider.
 
-(= gravity* 1.4 timebase* 120 front-threshold* 1)
+(= gravity* 1.8 timebase* 120 front-threshold* 1 
+   nourl-factor* .4 lightweight-factor* .3 )
 
-(def frontpage-rank (s (o gravity gravity*))
-  (/ (- (realscore s) 1)
-     (expt (/ (+ (item-age s) timebase*) 60) gravity)))
+(def frontpage-rank (s (o scorefn realscore) (o gravity gravity*))
+  (* (/ (let base (- (scorefn s) 1)
+          (if (> base 0) (expt base .8) base))
+        (expt (/ (+ (item-age s) timebase*) 60) gravity))
+     (if (no (in s!type 'story 'poll))  1
+         (blank s!url)                  nourl-factor*
+         (lightweight s)                (min lightweight-factor* 
+                                             (contro-factor s))
+                                        (contro-factor s))))
+
+(def contro-factor (s)
+  (aif (check (visible-family nil s) [> _ 20])
+       (min 1 (expt (/ (realscore s) it) 2))
+       1))
 
 (def realscore (i) (- i!score i!sockvotes))
 
-(def item-age (i) (hours-since i!time))
+(disktable lightweights* (+ newsdir* "lightweights"))
 
-(def user-age (u) (hours-since (uvar u created)))
+(def lightweight (s)
+  (or (mem 'rally s!keys)  ; title is a rallying cry
+      (mem 'image s!keys)  ; post is image(s), but without image extension
+      (or (lightweights* (sitename s!url))
+          (in (last (tokens s!url #\.)) 
+              "png" "PNG" "jpg" "JPG" "jpeg" "JPEG"))))
+
+(def item-age (i) (minutes-since i!time))
+
+(def user-age (u) (minutes-since (uvar u created)))
 
 ; Only looks at the 1000 most recent stories, which might one day be a 
 ; problem if there is massive spam. 
@@ -207,23 +327,38 @@
   (= ranked-stories* (rank-stories 180 1000 (memo frontpage-rank))))
 
 (def save-topstories ()
-  (writefile1 (map [_ 'id] (firstn 180 ranked-stories*))
-              (+ newsdir* "topstories")))
+  (writefile (map get!id (firstn 180 ranked-stories*))
+             (+ newsdir* "topstories")))
  
 (def rank-stories (n consider scorefn)
   (bestn n (compare > scorefn) (recent-stories consider)))
 
-; The n most recent stories.  Use firstn when add virtual lists.
+; The n most recent stories.
+
+; with virtual lists would write thus:
+; (map item (retrieve n metastory:item (gen maxid* [- _ 1])))
 
 (def recent-stories (n (o id maxid*) (o acc nil))
   (if (or (< n 1) (< id 1))
       (rev acc)
       (let s (item id)
-        (if (storylike s)
+        (if (metastory s)
             (recent-stories (- n 1) (- id 1) (cons s acc))
             (recent-stories n       (- id 1) acc)))))
 
-(def storylike (i) (and i (astory i)))
+(def recent-items (test minutes)
+  (with (cutoff (- (seconds) (* 60 minutes))
+         id     nil)
+    (accum a
+      (loop (= id maxid*) 
+            (and (> id 0) (> ((item id) 'time) cutoff)) 
+            (-- id)
+        (let i (item id)
+          (if (test i) (a i)))))))
+
+; redefined later
+
+(def metastory (i) (and i (in i!type 'story 'poll)))
 
 (def adjust-rank (s (o scorefn frontpage-rank))
   (insortnew (compare > (memo scorefn)) s ranked-stories*)
@@ -234,27 +369,35 @@
 ; thus get stuck in front of it. I avoid this by regularly adjusting 
 ; the rank of a random top story.
 
-(def rerank-random ((o depth 15))
+(defbg rerank-random 30 (rerank-random))
+
+(def rerank-random ()
   (when ranked-stories*
-    (adjust-rank (ranked-stories* (rand (min depth (len ranked-stories*))))))
-  (save-topstories))
+    (adjust-rank (ranked-stories* (rand (min 50 (len ranked-stories*)))))))
 
 (def topstories (user n (o threshold front-threshold*))
-  (firstn-that n 
-               [and (>= (realscore _) threshold) (cansee user _)]
-               ranked-stories*))
+  (retrieve n 
+            [and (>= (realscore _) threshold) (cansee user _)]
+            ranked-stories*))
 
-; If had ip of current request could add clause below to make ignore
-; tighter better, but wait till need to.
+(= max-delay* 10)
 
 (def cansee (user i)
-  (if i!deleted (admin user)
-      i!dead    (or (is user i!by) (seesdead user))
-                    ; ip of this request is i!ip
-                t))
+  (if i!deleted   (admin user)
+      i!dead      (or (author user i) (seesdead user))
+      (delayed i) (author user i)
+      t))
+
+(let mature (table)
+  (def delayed (i)
+    (and (no (mature i!id))
+         (acomment i)
+         (or (< (item-age i) (min max-delay* (uvar i!by delay)))
+             (do (set (mature i!id))
+                 nil)))))
 
 (def seesdead (user)
-  (or (and user (uvar user showdead) (no (uvar user ignore)))
+  (or (and user (uvar user showdead) (no (ignored user)))
       (editor user)))
 
 (def visible (user is)
@@ -278,10 +421,15 @@
 
 (defopr favicon.ico req favicon-url*)
 
+; redefined later
+
+(def gen-css-url ()
+  (prn "<link rel=\"stylesheet\" type=\"text/css\" href=\"news.css\">"))
+
 (mac npage (title . body)
   `(tag html 
      (tag head 
-       (prn "<link rel=\"stylesheet\" type=\"text/css\" href=\"news.css\">")
+       (gen-css-url)
        (prn "<link rel=\"shortcut icon\" href=\"" favicon-url* "\">")
        (tag script (pr votejs*))
        (tag title (pr ,title)))
@@ -293,20 +441,20 @@
 
 (= pagefns* nil)
 
-(mac fulltop (user label title whence . body)
-  (w/uniq (gu gl gt gw)
-    `(with (,gu ,user ,gl ,label ,gt ,title ,gw ,whence)
+(mac fulltop (user lid label title whence . body)
+  (w/uniq (gu gi gl gt gw)
+    `(with (,gu ,user ,gi ,lid ,gl ,label ,gt ,title ,gw ,whence)
        (npage (+ this-site* (if ,gt (+ bar* ,gt) ""))
          (if (check-procrast ,gu)
-             (do (pagetop 'full ,gl ,gt ,gu ,gw)
+             (do (pagetop 'full ,gi ,gl ,gt ,gu ,gw)
                  (hook 'page ,gu ,gl)
                  ,@body)
              (row (procrast-msg ,gu ,gw)))))))
 
-(mac longpage (user t1 label title whence . body)
-  (w/uniq (gu gt)
-    `(with (,gu ,user ,gt ,t1)
-       (fulltop ,gu ,label ,title ,whence
+(mac longpage (user t1 lid label title whence . body)
+  (w/uniq (gu gt gi)
+    `(with (,gu ,user ,gt ,t1 ,gi ,lid)
+       (fulltop ,gu ,gi ,label ,title ,whence
          (trtd ,@body)
          (trtd (vspace 10)
                (color-stripe (main-color ,gu))
@@ -320,6 +468,7 @@
     (br2)
     (w/bars
       (pr (len items*) "/" maxid* " loaded")
+      (pr (round (/ (memory) 1000000)) " mb")
       (pr elapsed " msec")
       (link "settings" "newsadmin")
       (hook 'admin-bar user whence))))
@@ -328,15 +477,22 @@
   (tag (table width "100%" cellspacing 0 cellpadding 1)
     (tr (tdcolor c))))
 
-(mac shortpage (user label title whence . body)
-  `(fulltop ,user ,label ,title ,whence 
+(mac shortpage (user lid label title whence . body)
+  `(fulltop ,user ,lid ,label ,title ,whence 
      (trtd ,@body)))
 
 (mac minipage (label . body)
   `(npage (+ this-site* bar* ,label)
-     (pagetop nil ,label)
+     (pagetop nil nil ,label)
      (trtd ,@body)))
 
+(def msgpage (user msg (o title))
+  (minipage (or title "Message")
+    (spanclass admin
+      (center (if (len> msg 80) 
+                  (widtable 500 msg)
+                  (pr msg))))
+    (br2)))
 
 ; remember to (= caching* 0) or won't see changes
 
@@ -381,7 +537,7 @@
 
 .pagebreak {page-break-before:always}
 
-pre { overflow: hidden; padding: 2px; }
+pre { overflow: auto; padding: 2px; max-width:600px; }
 pre:hover {overflow:auto} "))
 
 ; only need pre padding because of a bug in Mac Firefox
@@ -435,7 +591,7 @@
        (hex>color it)
        site-color*))
 
-(def pagetop (switch label (o title) (o user) (o whence))
+(def pagetop (switch lid label (o title) (o user) (o whence))
   (tr (tdcolor (main-color user)
         (tag (table border 0 cellpadding 0 cellspacing 0 width "100%"
                     style "padding:2px")
@@ -460,10 +616,16 @@
       (gentag img src logo-url* width 18 height 18 
                   style "border:1px white solid;"))))
 
-(= toplabels* '(nil "new" "threads" "comments" "leaders" "*"))
+(= toplabels* '(nil "welcome" "new" "threads" "comments" "leaders" "*"))
+
+; redefined later
+
+(= welcome-url* "welcome")
 
 (def toprow (user label)
   (w/bars 
+    (when (noob user)
+      (toplink "welcome" welcome-url* label)) 
     (toplink "new" "newest" label)
     (when user
       (toplink "threads" (threads-url user) label))
@@ -472,7 +634,7 @@
     (hook 'toprow user label)
     (link "submit")
     (unless (mem label toplabels*)
-      (tag (font color white) (pr label)))))
+      (fontcolor white (pr label)))))
 
 (def toplink (name dest label)
   (tag-if (is name label) (span class 'topsel)
@@ -480,7 +642,7 @@
 
 (def topright (user whence (o showkarma t))
   (when user 
-    (link user (user-url user))
+    (userlink user user nil)
     (when showkarma (pr  "&nbsp;(" (karma user) ")"))
     (pr "&nbsp;|&nbsp;"))
   (if user
@@ -492,9 +654,12 @@
         (login-page 'both nil 
                     (list (fn (u ip) 
                             (ensure-news-user u)
-                            (newslog u 'top-login ip))
+                            (newslog ip u 'top-login))
                           whence)))))
 
+(def noob (user)
+  (and user (< (days-since (uvar user created)) 1)))
+
 
 ; News-Specific Defop Variants
 
@@ -521,7 +686,7 @@
        (with (user (get-user ,gr) ip (,gr 'ip))
          (with ,(and parms (mappend [list _ (list 'arg gr (string _))]
                                     parms))
-           (newslog user ',name ip ,@parms)
+           (newslog ip user ',name ,@parms)
            ,@body)))))
 
 (= newsop-names* nil)
@@ -534,65 +699,73 @@
   (w/uniq g
     `(opexpand defopa ,name ,parms 
        (let ,g (string ',name)
-         (shortpage user ,g ,g ,g
+         (shortpage user nil ,g ,g ,g
+           ,@body)))))
+
+(mac edop (name parms . body)
+  (w/uniq g
+    `(opexpand defope ,name ,parms 
+       (let ,g (string ',name)
+         (shortpage user nil ,g ,g ,g
            ,@body)))))
 
 
 ; News Admin
 
-(defopa newsadmin req (newsadmin-page (get-user req)))
+(defopa newsadmin req 
+  (let user (get-user req)
+    (newslog req!ip user 'newsadmin)
+    (newsadmin-page user)))
 
-; For emergency, real-time changes.  All are reset to the val in the 
-; source code when restart server.
+; Note that caching* is reset to val in source when restart server.
 
 (def nad-fields ()
-  `((num      caching           ,caching*          t t)
-    (posint   front-threshold   ,front-threshold*  t t)
-    (int      legit-threshold   ,legit-threshold*  t t)
-    (bigtoks  url-kill          ,url-kill*         t t)
-    (bigtoks  url-ignore        ,url-ignore*       t t)
-    (bigtoks  comment-kill      ,comment-kill*     t t)
-    (bigtoks  comment-ignore    ,comment-ignore*   t t)
-    (bigtoks  ip-ban            ,ip-ban*           t t)))
+  `((num      caching         ,caching*                       t t)
+    (bigtoks  comment-kill    ,comment-kill*                  t t)
+    (bigtoks  comment-ignore  ,comment-ignore*                t t)
+    (bigtoks  lightweights    ,(sort < (keys lightweights*))  t t)))
 
 ; Need a util like vars-form for a collection of variables.
 ; Or could generalize vars-form to think of places (in the setf sense).
 
 (def newsadmin-page (user)
-  (newslog user 'newsadmin)
-  (shortpage user "newsadmin" "News Admin Page" "newsadmin"
-    (vars-form user (nad-fields)
+  (shortpage user nil nil "newsadmin" "newsadmin"
+    (vars-form user 
+               (nad-fields)
                (fn (name val)
                  (case name
                    caching            (= caching* val)
-                   front-threshold    (= front-threshold* val)
-                   legit-threshold    (= legit-threshold* val)
-                   url-kill           (= url-kill* val)
-                   url-ignore         (= url-ignore* val)
-                   comment-kill       (= comment-kill* val)
-                   comment-ignore     (= comment-ignore* val)
-                   ip-ban             (= ip-ban* val)))
+                   comment-kill       (todisk comment-kill* val)
+                   comment-ignore     (todisk comment-ignore* val)
+                   lightweights       (todisk lightweights* (memtable val))
+                   ))
                (fn () (newsadmin-page user))) 
     (br2)
     (aform (fn (req)
              (with (user (get-user req) subject (arg req "id"))
-               (if (profs* subject)
+               (if (profile subject)
                    (do (killallby subject)
                        (submitted-page user subject))
                    (if (admin user) (newsadmin-page user)))))
-      (single-input "" 'id 20 "kill all by"))))
+      (single-input "" 'id 20 "kill all by"))
+    (br2)
+    (aform (fn (req)
+             (let user (get-user req)
+               (set-ip-ban user (arg req "ip") t)
+               (if (admin user) (newsadmin-page user))))
+      (single-input "" 'ip 20 "ban ip"))))
 
 
 ; Users
 
 (newsop user (id)
-  (if (profs* id)
+  (if (only.profile id)
       (user-page user id)
       (pr "No such user.")))
 
 (def user-page (user subject)
   (let here (user-url subject)
-    (shortpage user nil (+ "Profile: " subject) here
+    (shortpage user nil nil (+ "Profile: " subject) here
       (profile-form user subject)
       (br2)
       (when (some astory:item (uvar subject submitted))
@@ -603,7 +776,7 @@
       (hook 'user user subject))))
 
 (def profile-form (user subject)
-  (let prof (profs* subject) 
+  (let prof (profile subject) 
     (vars-form user
                (user-fields user subject)
                (fn (name val) (= (prof name) val))
@@ -619,7 +792,7 @@
           k (and w (> (karma user) topcolor-threshold*))
           u (or a w)
           m (or a (and (member user) w))
-          p (profs* subject))
+          p (profile subject))
     `((string  user       ,subject                                  t   nil)
       (string  name       ,(p 'name)                               ,m  ,m)
       (string  created    ,(text-age:user-age subject)              t   nil)
@@ -628,10 +801,10 @@
       (int     auth       ,(p 'auth)                               ,e  ,a)
       (yesno   member     ,(p 'member)                             ,a  ,a)
       (posint  karma      ,(p 'karma)                               t  ,a)
+      (num     avg        ,(p 'avg)                                ,a  nil)
       (yesno   ignore     ,(p 'ignore)                             ,e  ,e)
       (num     weight     ,(p 'weight)                             ,a  ,a)
-      (yesno   nodowns    ,(p 'nodowns)                            ,a  ,a)
-      (mdtext  about      ,(p 'about)                               t  ,u)
+      (mdtext2 about      ,(p 'about)                               t  ,u)
       (string  email      ,(p 'email)                              ,u  ,u)
       (yesno   showdead   ,(p 'showdead)                           ,u  ,u)
       (yesno   noprocrast ,(p 'noprocrast)                         ,u  ,u)
@@ -640,11 +813,15 @@
       (posint  maxvisit   ,(p 'maxvisit)                           ,u  ,u)
       (posint  minaway    ,(p 'minaway)                            ,u  ,u)
       (sexpr   keys       ,(p 'keys)                               ,a  ,a)
-      (hexcol  topcolor   ,(or (p 'topcolor) (hexrep site-color*)) ,k  ,k))))
+      (hexcol  topcolor   ,(or (p 'topcolor) (hexrep site-color*)) ,k  ,k)
+      (int     delay      ,(p 'delay)                              ,u  ,u)
+      )))
 
 (def saved-link (user subject)
   (when (or (admin user) (is user subject))
-    (let n (len (voted-stories user subject))
+    (let n (if (len> (votes subject) 500) 
+               "many" 
+               (len (voted-stories user subject)))
       (if (is n 0)
           ""
           (tostring (underlink n (saved-url subject)))))))
@@ -652,12 +829,15 @@
 (def resetpw-link ()
   (tostring (underlink "reset password" "resetpw")))
 
+(newsop welcome ()
+  (pr "Welcome to " this-site* ", " user "!"))
+
 
 ; Main Operators
 
 ; remember to set caching to 0 when testing non-logged-in 
 
-(= caching* 0 perpage* 30 maxend* 200)
+(= caching* 1 perpage* 30 threads-perpage* 10 maxend* 210)
 
 ; Limiting that newscache can't take any arguments except the user.
 ; To allow other arguments, would have to turn the cache from a single 
@@ -680,12 +860,11 @@
 ;(newsop index.html () (newspage user))
 
 (newscache newspage user 90
-  (rerank-random)
-  (listpage user (msec) (topstories user maxend*) nil nil "news" t))
+  (listpage user (msec) (topstories user maxend*) nil nil "news"))
 
-(def listpage (user t1 items label title (o url label) (o number))
+(def listpage (user t1 items label title (o url label) (o number t))
   (hook 'listpage user)
-  (longpage user t1 label title url
+  (longpage user t1 nil label title url
     (display-items user items label title url 0 perpage* number)))
 
 
@@ -695,17 +874,16 @@
 ; cached page.  If this were a prob, could make deletion clear caches.
 
 (newscache newestpage user 40
-  (rerank-random)
-  (listpage user (msec) (newstories user maxend*) "new" "New Links" "newest" t))
+  (listpage user (msec) (newstories user maxend*) "new" "New Links" "newest"))
 
 (def newstories (user n)
-  (firstn-that n [cansee user _] stories*))
+  (retrieve n [cansee user _] stories*))
 
 
 (newsop best () (bestpage user))
 
 (newscache bestpage user 1000
-  (listpage user (msec) (beststories user maxend*) "best" "Top Links" "best" t))
+  (listpage user (msec) (beststories user maxend*) "best" "Top Links"))
 
 ; As no of stories gets huge, could test visibility in fn sent to best.
 
@@ -713,33 +891,45 @@
   (bestn n (compare > realscore) (visible user stories*)))
 
 
+(newsop noobs () (noobpage user))
+
+(def noobpage (user)
+  (listpage user (msec) (noobstories user maxend*) "noobs" "New Accounts"))
+
+(def noobstories (user n)
+  (retrieve n [and (cansee user _) (bynoob _)] stories*))
+
+(def bynoob (i)
+  (< (- (user-age i!by) (item-age i)) 2880))
+
+
 (newsop bestcomments () (bestcpage user))
 
 (newscache bestcpage user 1000
   (listpage user (msec) (bestcomments user maxend*) 
-            "best comments" "Best Comments" "bestcomments"))
+            "best comments" "Best Comments" "bestcomments" nil))
 
 (def bestcomments (user n)
   (bestn n (compare > realscore) (visible user comments*)))
 
 
 (newsop lists () 
-  (longpage user (msec) "lists" "Lists" "lists"
-    (tag table
-      (row "" (hspace 10))
-      (row (link "best")         "" "Highest voted recent links.")
-      (row (link "active")       "" "Most active current discussions.")
-      (row (link "bestcomments") "" "Highest voted recent comments.")
+  (longpage user (msec) nil "lists" "Lists" "lists"
+    (sptab
+      (row (link "best")         "Highest voted recent links.")
+      (row (link "active")       "Most active current discussions.")
+      (row (link "bestcomments") "Highest voted recent comments.")
+      (row (link "noobs")        "Submissions from new accounts.")
       (when (admin user)
         (map [row (link _)] 
-             '(optimes killed badguys badlogins goodlogins)))
+             '(optimes topips flagged killed badguys badlogins goodlogins)))
       (hook 'listspage user))))
 
 
 (def saved-url (user) (string "saved?id=" user))
 
 (newsop saved (id) 
-  (if (profs* id) 
+  (if (only.profile id)
       (savedpage user id) 
       (pr "No such user.")))
 
@@ -747,12 +937,12 @@
   (if (or (is user subject) (admin user))
       (listpage user (msec)
                 (sort (compare < item-age) (voted-stories user subject)) 
-               "saved" "Saved Links" (saved-url subject) t)
+               "saved" "Saved Links" (saved-url subject))
       (pr "Can't display that.")))
 
 (def voted-stories (user subject)
   (keep [and (astory _) (cansee user _)]
-        (map item (keys:votes* subject))))
+        (map item (keys:votes subject))))
 
 
 ; Story Display
@@ -761,14 +951,14 @@
                     (o start 0) (o end perpage*) (o number))
   (zerotable
     (let n start
-      (each i (if end (cut items start end) items)
+      (each i (cut items start end)
         (display-item (and number (++ n)) i user whence t)
         (spacerow (if (acomment i) 15 5))))
     (when end
       (let newend (+ end perpage*)
         (when (and (<= newend maxend*) (< end (len items)))
           (spacerow 10)
-          (tr (tag (td colspan  (if number 2 1)))
+          (tr (tag (td colspan (if number 2 1)))
               (tag (td class 'title)
                 (morelink items label title end newend number))))))))
 
@@ -781,8 +971,8 @@
                  (afnid (fn (req)
                           (prn)
                           (let user (get-user req)
-                            (newslog user 'more label)
-                            (longpage user (msec) label title (url-for it)
+                            (newslog req!ip user 'more label)
+                            (longpage user (msec) nil label title (url-for it)
                               (display-items user items
                                              label title (url-for it)
                                              end newend number))))))
@@ -793,19 +983,18 @@
   (when (or (cansee user s) (s 'kids))
     (tr (display-item-number i)
         (td (votelinks s user whence))
-        (titlelink s s!url user))
+        (titleline s s!url user whence))
     (tr (tag (td colspan (if i 2 1)))    
         (tag (td class 'subtext)
           (hook 'itemline s user)
           (itemline s user)
-          (when (astory s) (commentlink s user))
+          (when (in s!type 'story 'poll) (commentlink s user))
           (editlink s user)
-          (when (admin user)
-            (pr bar*)
-            (w/rlink (do (zap no s!dead)
-                         (save-item s)
-                         whence)
-              (pr (if (s 'dead) "unkill" "kill"))))
+          (when (apoll s) (addoptlink s user))
+          (unless i (flaglink s user whence))
+          (killlink s user whence)
+          (blastlink s user whence)
+          (blastlink s user whence t)
           (deletelink s user whence)))))
 
 (def display-item-number (i)
